local isConfiguring = false;

BINDING_HEADER_MALOWINCANTERSFLOW = "MaloWIncantersFlow";
SLASH_MALOWINCANTERSFLOW1 = "/mif";
SLASH_MALOWINCANTERSFLOW2 = "/malowincantersflow";
local function MaloWIncantersFlow_SlashHandler(msg, editbox)
	if msg == "" or msg == nil then
		MaloWIncantersFlow_PrintMenu();
	end
	if msg == "lock" then
		
	end
	if msg == "combat" then
		
	end
	if msg == "resetpos" then
		MaloWIncantersFlowFrame:SetPoint("TOPLEFT", nil, "TOPLEFT", 400, -400);
	end
	if msg == "show" then
		MaloWIncantersFlowFrame:Show();
		isConfiguring = true;
		print("MaloWIncantersFlow is now being shown for configuration, type '/mif hide' to hide it when you're done");
	end
	if msg == "hidetexts" then
    if MaloWIncantersFlowSVHideTexts then
      MaloWIncantersFlowSVHideTexts = false;
    else
      MaloWIncantersFlowSVHideTexts = true;
    end
  end
	if msg == "hide" then
		MaloWIncantersFlowFrame:Hide();
		isConfiguring = false;
		print("MaloWIncantersFlow is now hidden, it will automatically show when you're in combat and have Incanter's Flow as a buff");
	end
	if string.match(msg, "scale") then
		local scale = string.sub(msg, 7);
		MaloWIncantersFlowFrame:SetScale(scale);
		MaloWIncantersFlowSVScale = scale;
	end
end 
SlashCmdList["MALOWINCANTERSFLOW"] = MaloWIncantersFlow_SlashHandler;

function MaloWIncantersFlow_PrintMenu()
	print("MaloWIncantersFlow: Arguments to /mif :");
	print("scale - Scales the frame. Default 1.0");
	--print("lock - Toggles the frame being locked from movement");
	--print("combat - Toggles if the frame will hide when you leave combat");
	print("show - Shows the frame so you can configure it. Type '/mif hide' when you're done");
	print("hide - Hides the frames");
	print("resetpos - Resets the position of the frame");
	print("hidetexts - Toggles texts for stacks and timer being shown");
end


local previousStacks = 0;
local previousStacksTime = 0;
local previousUpdateTime = 0;
local increasing = true;

function MaloWIncantersFlow_OnEvent(self, event, arg1, ...)
	if event == "ADDON_LOADED" and arg1 == "MaloWIncantersFlow" then
		if MaloWIncantersFlowSVScale == nil then
			MaloWIncantersFlowSVScale = 1.0;
		else
			MaloWIncantersFlowFrame:SetScale(MaloWIncantersFlowSVScale);
		end
    if MaloWIncantersFlowSVHideTexts == nil then
      MaloWIncantersFlowSVHideTexts = false;
    end
	elseif event == "UNIT_AURA" then
    if arg1 == "player" then
      MaloWIncantersFlow_Update();
    end
	end
end 

function MaloWIncantersFlow_OnUpdate(self, elapsed)
  if GetTime() < previousUpdateTime + 0.1 then
    return;
  end
  previousUpdateTime = GetTime();
	MaloWIncantersFlow_Update();
end

function MaloWIncantersFlow_Update()  
	local stacks = getIncantersFlowStacks();
	if isConfiguring == true then
		stacks = 3;
	else
		if stacks == 0 or UnitAffectingCombat("player") == false then
			MaloWIncantersFlowFrame:Hide();
			return;
		end
	end
	
	MaloWIncantersFlowFrame:Show();
  if MaloWIncantersFlowSVHideTexts then
    MaloWIncantersFlowFrameStackText:Hide();
    MaloWIncantersFlowFrameNextText:Hide();
  else
    MaloWIncantersFlowFrameStackText:Show();
    MaloWIncantersFlowFrameNextText:Show();
  end
	
	if previousStacks < stacks then
		increasing = true;
	elseif previousStacks > stacks then
		increasing = false;
	end
	
	local timeToNext = string.sub(tostring(getTimeUntillNext(stacks, increasing)), 1, 3);
	MaloWIncantersFlowFrameStackText:SetText(stacks);
	MaloWIncantersFlowFrameNextText:SetText(timeToNext);
	
	updateIcons(stacks, increasing);
	
	if stacks ~= previousStacks then
		previousStacksTime = GetTime();
		previousStacks = stacks;
	end
end

function getTimeUntillNext(stacks, increasing)
	local timeSincePrevious = GetTime() - previousStacksTime;
	local timeToNext = 0;
	if stacks == 5 then
		return 2 - timeSincePrevious;
	end
	if increasing then
		timeToNext = 5 - stacks;
	else
		timeToNext = stacks + 4;
	end
	return timeToNext - timeSincePrevious;
end



function updateIcons(stacks, increasing)
	if stacks == 5 then
		MaloWIncantersFlowFrameTopOverlay:SetTexture(0, 1, 0, 1.0);
		MaloWIncantersFlowFrameFifthIcon:Show();
	else
		MaloWIncantersFlowFrameFifthIcon:Hide();
		if increasing then
			MaloWIncantersFlowFrameTopOverlay:SetTexture(1, 1, 0, 1.0);
		else
			MaloWIncantersFlowFrameTopOverlay:SetTexture(1, 0, 0, 1.0);
		end
	end
	
	if stacks >= 4 then
		MaloWIncantersFlowFrameFourthIcon:Show();
	else
		MaloWIncantersFlowFrameFourthIcon:Hide();
	end
	
	if stacks >= 3 then
		MaloWIncantersFlowFrameThirdIcon:Show();
	else
		MaloWIncantersFlowFrameThirdIcon:Hide();
	end
	
	if stacks >= 2 then
		MaloWIncantersFlowFrameSecondIcon:Show();
	else
		MaloWIncantersFlowFrameSecondIcon:Hide();
	end
	
	if stacks >= 1 then
		MaloWIncantersFlowFrameFirstIcon:Show();
	else
		MaloWIncantersFlowFrameFirstIcon:Hide();
	end
end

function getIncantersFlowStacks()
	for i = 1, 40 do 
		local _,_,_,stacks, _, _, _, _, _, _, spellId = UnitBuff("player", i);
		if spellId == 116267 then
			return stacks;
		end 
	end
	return 0;
end
